# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.code_type import CodeType  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.enumeration_concept_map_equivalence import EnumerationConceptMapEquivalence  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.other_element_component import OtherElementComponent  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501


class TargetElementComponent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'extension': 'list[Extension]',
        'disallow_extensions': 'bool',
        'modifier_extension': 'list[Extension]',
        'code': 'str',
        'display': 'str',
        'equivalence': 'str',
        'comment': 'str',
        'depends_on': 'list[OtherElementComponent]',
        'product': 'list[OtherElementComponent]',
        'equivalence_element': 'EnumerationConceptMapEquivalence',
        'depends_on_first_rep': 'OtherElementComponent',
        'product_first_rep': 'OtherElementComponent',
        'code_element': 'CodeType',
        'display_element': 'StringType',
        'comment_element': 'StringType',
        'empty': 'bool',
        'modifier_extension_first_rep': 'Extension',
        'id_element': 'StringType',
        'extension_first_rep': 'Extension',
        'id_base': 'str',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool',
        'primitive': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'extension': 'extension',
        'disallow_extensions': 'disallowExtensions',
        'modifier_extension': 'modifierExtension',
        'code': 'code',
        'display': 'display',
        'equivalence': 'equivalence',
        'comment': 'comment',
        'depends_on': 'dependsOn',
        'product': 'product',
        'equivalence_element': 'equivalenceElement',
        'depends_on_first_rep': 'dependsOnFirstRep',
        'product_first_rep': 'productFirstRep',
        'code_element': 'codeElement',
        'display_element': 'displayElement',
        'comment_element': 'commentElement',
        'empty': 'empty',
        'modifier_extension_first_rep': 'modifierExtensionFirstRep',
        'id_element': 'idElement',
        'extension_first_rep': 'extensionFirstRep',
        'id_base': 'idBase',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime',
        'primitive': 'primitive'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, extension=None, disallow_extensions=None, modifier_extension=None, code=None, display=None, equivalence=None, comment=None, depends_on=None, product=None, equivalence_element=None, depends_on_first_rep=None, product_first_rep=None, code_element=None, display_element=None, comment_element=None, empty=None, modifier_extension_first_rep=None, id_element=None, extension_first_rep=None, id_base=None, resource=None, boolean_primitive=None, date_time=None, primitive=None):  # noqa: E501
        """TargetElementComponent - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._extension = None
        self._disallow_extensions = None
        self._modifier_extension = None
        self._code = None
        self._display = None
        self._equivalence = None
        self._comment = None
        self._depends_on = None
        self._product = None
        self._equivalence_element = None
        self._depends_on_first_rep = None
        self._product_first_rep = None
        self._code_element = None
        self._display_element = None
        self._comment_element = None
        self._empty = None
        self._modifier_extension_first_rep = None
        self._id_element = None
        self._extension_first_rep = None
        self._id_base = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self._primitive = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if extension is not None:
            self.extension = extension
        if disallow_extensions is not None:
            self.disallow_extensions = disallow_extensions
        if modifier_extension is not None:
            self.modifier_extension = modifier_extension
        if code is not None:
            self.code = code
        if display is not None:
            self.display = display
        if equivalence is not None:
            self.equivalence = equivalence
        if comment is not None:
            self.comment = comment
        if depends_on is not None:
            self.depends_on = depends_on
        if product is not None:
            self.product = product
        if equivalence_element is not None:
            self.equivalence_element = equivalence_element
        if depends_on_first_rep is not None:
            self.depends_on_first_rep = depends_on_first_rep
        if product_first_rep is not None:
            self.product_first_rep = product_first_rep
        if code_element is not None:
            self.code_element = code_element
        if display_element is not None:
            self.display_element = display_element
        if comment_element is not None:
            self.comment_element = comment_element
        if empty is not None:
            self.empty = empty
        if modifier_extension_first_rep is not None:
            self.modifier_extension_first_rep = modifier_extension_first_rep
        if id_element is not None:
            self.id_element = id_element
        if extension_first_rep is not None:
            self.extension_first_rep = extension_first_rep
        if id_base is not None:
            self.id_base = id_base
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time
        if primitive is not None:
            self.primitive = primitive

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this TargetElementComponent.  # noqa: E501


        :return: The format_comments_pre of this TargetElementComponent.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this TargetElementComponent.


        :param format_comments_pre: The format_comments_pre of this TargetElementComponent.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this TargetElementComponent.  # noqa: E501


        :return: The format_comments_post of this TargetElementComponent.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this TargetElementComponent.


        :param format_comments_post: The format_comments_post of this TargetElementComponent.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this TargetElementComponent.  # noqa: E501


        :return: The id of this TargetElementComponent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TargetElementComponent.


        :param id: The id of this TargetElementComponent.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def extension(self):
        """Gets the extension of this TargetElementComponent.  # noqa: E501


        :return: The extension of this TargetElementComponent.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this TargetElementComponent.


        :param extension: The extension of this TargetElementComponent.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def disallow_extensions(self):
        """Gets the disallow_extensions of this TargetElementComponent.  # noqa: E501


        :return: The disallow_extensions of this TargetElementComponent.  # noqa: E501
        :rtype: bool
        """
        return self._disallow_extensions

    @disallow_extensions.setter
    def disallow_extensions(self, disallow_extensions):
        """Sets the disallow_extensions of this TargetElementComponent.


        :param disallow_extensions: The disallow_extensions of this TargetElementComponent.  # noqa: E501
        :type: bool
        """

        self._disallow_extensions = disallow_extensions

    @property
    def modifier_extension(self):
        """Gets the modifier_extension of this TargetElementComponent.  # noqa: E501


        :return: The modifier_extension of this TargetElementComponent.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._modifier_extension

    @modifier_extension.setter
    def modifier_extension(self, modifier_extension):
        """Sets the modifier_extension of this TargetElementComponent.


        :param modifier_extension: The modifier_extension of this TargetElementComponent.  # noqa: E501
        :type: list[Extension]
        """

        self._modifier_extension = modifier_extension

    @property
    def code(self):
        """Gets the code of this TargetElementComponent.  # noqa: E501


        :return: The code of this TargetElementComponent.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this TargetElementComponent.


        :param code: The code of this TargetElementComponent.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def display(self):
        """Gets the display of this TargetElementComponent.  # noqa: E501


        :return: The display of this TargetElementComponent.  # noqa: E501
        :rtype: str
        """
        return self._display

    @display.setter
    def display(self, display):
        """Sets the display of this TargetElementComponent.


        :param display: The display of this TargetElementComponent.  # noqa: E501
        :type: str
        """

        self._display = display

    @property
    def equivalence(self):
        """Gets the equivalence of this TargetElementComponent.  # noqa: E501


        :return: The equivalence of this TargetElementComponent.  # noqa: E501
        :rtype: str
        """
        return self._equivalence

    @equivalence.setter
    def equivalence(self, equivalence):
        """Sets the equivalence of this TargetElementComponent.


        :param equivalence: The equivalence of this TargetElementComponent.  # noqa: E501
        :type: str
        """
        allowed_values = ["RELATEDTO", "EQUIVALENT", "EQUAL", "WIDER", "SUBSUMES", "NARROWER", "SPECIALIZES", "INEXACT", "UNMATCHED", "DISJOINT", "NULL"]  # noqa: E501
        if equivalence not in allowed_values:
            raise ValueError(
                "Invalid value for `equivalence` ({0}), must be one of {1}"  # noqa: E501
                .format(equivalence, allowed_values)
            )

        self._equivalence = equivalence

    @property
    def comment(self):
        """Gets the comment of this TargetElementComponent.  # noqa: E501


        :return: The comment of this TargetElementComponent.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this TargetElementComponent.


        :param comment: The comment of this TargetElementComponent.  # noqa: E501
        :type: str
        """

        self._comment = comment

    @property
    def depends_on(self):
        """Gets the depends_on of this TargetElementComponent.  # noqa: E501


        :return: The depends_on of this TargetElementComponent.  # noqa: E501
        :rtype: list[OtherElementComponent]
        """
        return self._depends_on

    @depends_on.setter
    def depends_on(self, depends_on):
        """Sets the depends_on of this TargetElementComponent.


        :param depends_on: The depends_on of this TargetElementComponent.  # noqa: E501
        :type: list[OtherElementComponent]
        """

        self._depends_on = depends_on

    @property
    def product(self):
        """Gets the product of this TargetElementComponent.  # noqa: E501


        :return: The product of this TargetElementComponent.  # noqa: E501
        :rtype: list[OtherElementComponent]
        """
        return self._product

    @product.setter
    def product(self, product):
        """Sets the product of this TargetElementComponent.


        :param product: The product of this TargetElementComponent.  # noqa: E501
        :type: list[OtherElementComponent]
        """

        self._product = product

    @property
    def equivalence_element(self):
        """Gets the equivalence_element of this TargetElementComponent.  # noqa: E501


        :return: The equivalence_element of this TargetElementComponent.  # noqa: E501
        :rtype: EnumerationConceptMapEquivalence
        """
        return self._equivalence_element

    @equivalence_element.setter
    def equivalence_element(self, equivalence_element):
        """Sets the equivalence_element of this TargetElementComponent.


        :param equivalence_element: The equivalence_element of this TargetElementComponent.  # noqa: E501
        :type: EnumerationConceptMapEquivalence
        """

        self._equivalence_element = equivalence_element

    @property
    def depends_on_first_rep(self):
        """Gets the depends_on_first_rep of this TargetElementComponent.  # noqa: E501


        :return: The depends_on_first_rep of this TargetElementComponent.  # noqa: E501
        :rtype: OtherElementComponent
        """
        return self._depends_on_first_rep

    @depends_on_first_rep.setter
    def depends_on_first_rep(self, depends_on_first_rep):
        """Sets the depends_on_first_rep of this TargetElementComponent.


        :param depends_on_first_rep: The depends_on_first_rep of this TargetElementComponent.  # noqa: E501
        :type: OtherElementComponent
        """

        self._depends_on_first_rep = depends_on_first_rep

    @property
    def product_first_rep(self):
        """Gets the product_first_rep of this TargetElementComponent.  # noqa: E501


        :return: The product_first_rep of this TargetElementComponent.  # noqa: E501
        :rtype: OtherElementComponent
        """
        return self._product_first_rep

    @product_first_rep.setter
    def product_first_rep(self, product_first_rep):
        """Sets the product_first_rep of this TargetElementComponent.


        :param product_first_rep: The product_first_rep of this TargetElementComponent.  # noqa: E501
        :type: OtherElementComponent
        """

        self._product_first_rep = product_first_rep

    @property
    def code_element(self):
        """Gets the code_element of this TargetElementComponent.  # noqa: E501


        :return: The code_element of this TargetElementComponent.  # noqa: E501
        :rtype: CodeType
        """
        return self._code_element

    @code_element.setter
    def code_element(self, code_element):
        """Sets the code_element of this TargetElementComponent.


        :param code_element: The code_element of this TargetElementComponent.  # noqa: E501
        :type: CodeType
        """

        self._code_element = code_element

    @property
    def display_element(self):
        """Gets the display_element of this TargetElementComponent.  # noqa: E501


        :return: The display_element of this TargetElementComponent.  # noqa: E501
        :rtype: StringType
        """
        return self._display_element

    @display_element.setter
    def display_element(self, display_element):
        """Sets the display_element of this TargetElementComponent.


        :param display_element: The display_element of this TargetElementComponent.  # noqa: E501
        :type: StringType
        """

        self._display_element = display_element

    @property
    def comment_element(self):
        """Gets the comment_element of this TargetElementComponent.  # noqa: E501


        :return: The comment_element of this TargetElementComponent.  # noqa: E501
        :rtype: StringType
        """
        return self._comment_element

    @comment_element.setter
    def comment_element(self, comment_element):
        """Sets the comment_element of this TargetElementComponent.


        :param comment_element: The comment_element of this TargetElementComponent.  # noqa: E501
        :type: StringType
        """

        self._comment_element = comment_element

    @property
    def empty(self):
        """Gets the empty of this TargetElementComponent.  # noqa: E501


        :return: The empty of this TargetElementComponent.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this TargetElementComponent.


        :param empty: The empty of this TargetElementComponent.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def modifier_extension_first_rep(self):
        """Gets the modifier_extension_first_rep of this TargetElementComponent.  # noqa: E501


        :return: The modifier_extension_first_rep of this TargetElementComponent.  # noqa: E501
        :rtype: Extension
        """
        return self._modifier_extension_first_rep

    @modifier_extension_first_rep.setter
    def modifier_extension_first_rep(self, modifier_extension_first_rep):
        """Sets the modifier_extension_first_rep of this TargetElementComponent.


        :param modifier_extension_first_rep: The modifier_extension_first_rep of this TargetElementComponent.  # noqa: E501
        :type: Extension
        """

        self._modifier_extension_first_rep = modifier_extension_first_rep

    @property
    def id_element(self):
        """Gets the id_element of this TargetElementComponent.  # noqa: E501


        :return: The id_element of this TargetElementComponent.  # noqa: E501
        :rtype: StringType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this TargetElementComponent.


        :param id_element: The id_element of this TargetElementComponent.  # noqa: E501
        :type: StringType
        """

        self._id_element = id_element

    @property
    def extension_first_rep(self):
        """Gets the extension_first_rep of this TargetElementComponent.  # noqa: E501


        :return: The extension_first_rep of this TargetElementComponent.  # noqa: E501
        :rtype: Extension
        """
        return self._extension_first_rep

    @extension_first_rep.setter
    def extension_first_rep(self, extension_first_rep):
        """Sets the extension_first_rep of this TargetElementComponent.


        :param extension_first_rep: The extension_first_rep of this TargetElementComponent.  # noqa: E501
        :type: Extension
        """

        self._extension_first_rep = extension_first_rep

    @property
    def id_base(self):
        """Gets the id_base of this TargetElementComponent.  # noqa: E501


        :return: The id_base of this TargetElementComponent.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this TargetElementComponent.


        :param id_base: The id_base of this TargetElementComponent.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def resource(self):
        """Gets the resource of this TargetElementComponent.  # noqa: E501


        :return: The resource of this TargetElementComponent.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this TargetElementComponent.


        :param resource: The resource of this TargetElementComponent.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this TargetElementComponent.  # noqa: E501


        :return: The boolean_primitive of this TargetElementComponent.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this TargetElementComponent.


        :param boolean_primitive: The boolean_primitive of this TargetElementComponent.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this TargetElementComponent.  # noqa: E501


        :return: The date_time of this TargetElementComponent.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this TargetElementComponent.


        :param date_time: The date_time of this TargetElementComponent.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    @property
    def primitive(self):
        """Gets the primitive of this TargetElementComponent.  # noqa: E501


        :return: The primitive of this TargetElementComponent.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this TargetElementComponent.


        :param primitive: The primitive of this TargetElementComponent.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TargetElementComponent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
